'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');
var view = require('@codemirror/view');
var lint = require('@codemirror/lint');
var autocomplete = require('@codemirror/autocomplete');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "#`OVQPOOOVQPO'#ClQhQPOOOOQO'#Ck'#CkOmQPO'#CkOrQPO,59WOVQPO,59XOzQPO'#CeOOQO,59V,59VOOQO1G.r1G.rOOQO1G.s1G.sO!RQPO'#CnO!^QPO,59POVQPO'#CgO!cQPO,59YOOQO1G.k1G.kO!kQPO,59ROOQO-E6e-E6e",
  stateData: "!y~O^OS~OQRORROSROTPOWSO~OVUO~OTVO~OUXOVUO~OUbP~PVOVUOY]OUbX~OU_O~OY]OUba~OVUOUZaYZa~OVR~",
  goto: "!WcPPPPPPPPPdPgPPPm||!TRWSQ^ZRa^QQOQTPQYUQZVR`]ZROPUV]R[V",
  nodeNames: "⚠ NuFormula String Number Item ( ) Operator Keyword ArgList Comma",
  maxTerm: 18,
  nodeProps: [
    ["closedBy", 5,")"],
    ["openedBy", 6,"("]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "+r~RfXY!gYZ!g]^!gpq!grs!lxy%Uyz%Zz{%`{|%e|}&Z}!O%e!O!P%p!P!Q%`!Q![&O!^!_&`!_!`%`!`!a&k!c!d&s!e!f'n!k!l(^!u!v(d#o#p(p~!lO^~~!oWpq!lqr!lrs#Xs#O!l#O#P#^#P;'S!l;'S;=`%O<%lO!l~#^OQ~~#aXrs!l!P!Q!l#O#P!l#U#V!l#Y#Z!l#b#c!l#f#g!l#h#i!l#i#j#|~$PR!Q![$Y!c!i$Y#T#Z$Y~$]R!Q![$f!c!i$f#T#Z$f~$iR!Q![$r!c!i$r#T#Z$r~$uR!Q![!l!c!i!l#T#Z!l~%RP;=`<%l!l~%ZOT~~%`OU~~%eOV~~%jQV~!O!P%p!Q![&O~%sP!Q![%v~%{PR~!Q![%v~&TQR~!O!P%v!Q![&O~&`OY~~&eQV~!_!`%`!`!a%`~&pPV~!_!`%`~&vP!x!y&y~&|P!g!h'P~'SP!t!u'V~'YP!c!d']~'`P!i!j'c~'fP!g!h'i~'nOW~~'qP!q!r't~'wP!p!q'z~'}P!e!f(Q~(TP!c!d(W~(ZP!v!w'i~(aP!h!i'i~(gP!w!x(j~(mP!o!p'i~(sR!Q![(|!c!i(|#T#Z(|~)PS}!O)]!Q![(|!c!i(|#T#Z(|~)`R!Q![)i!c!i)i#T#Z)i~)lS}!O)x!Q![)i!c!i)i#T#Z)i~){R!Q![*U!c!i*U#T#Z*U~*XS}!O*e!Q![*U!c!i*U#T#Z*U~*hR!Q![*q!c!i*q#T#Z*q~*tS}!O+Q!Q![*q!c!i*q#T#Z*q~+TR!Q![+^!c!i+^#T#Z+^~+aS!Q![+^!c!i+^#T#Z+^#q#r+m~+rOS~",
  tokenizers: [0],
  topRules: {"NuFormula":[0,1]},
  tokenPrec: 84
});

/**
 * 輸出 表單元件 decoration 插件
 *
 * @param {object} formItems - 所有表單元件
 * @returns {ViewPlugin}
 */
function nuformulaItemWidget(formItems) {
    // 表單項目單元
    class ItemWidget extends view.WidgetType {
        constructor(item, isError) {
            var _a;
            super();
            this.text = (_a = item.options) === null || _a === void 0 ? void 0 : _a.label;
            this.isError = isError;
        }
        toDOM() {
            let wrap = document.createElement("span");
            wrap.style.cssText = `
          border-radius: 4px;
          color: #6e7796;
          padding: 2px 4px;
          background-color: ${this.isError ? '#f00' : '#e9ebf2'};
        `;
            wrap.innerText = this.text;
            return wrap;
        }
        ignoreEvent() {
            return false;
        }
    }
    /**
     * 建立元件標籤
     *
     * @param { EditorView } view - EditorView
     * @returns { DecorationSet }
     */
    function itemTag(view$1) {
        let widgets = [];
        for (let { from, to } of view$1.visibleRanges) {
            language.syntaxTree(view$1.state).iterate({
                from,
                to,
                enter: (node) => {
                    var _a;
                    if (node.name == "Item") {
                        const itemSn = view$1.state.doc.sliceString(node.from + 1, node.to - 1);
                        const item = (_a = formItems[itemSn]) !== null && _a !== void 0 ? _a : {};
                        let deco = view.Decoration.replace({
                            widget: new ItemWidget(item, node.type.isError),
                            side: 1,
                        });
                        widgets.push(deco.range(node.from, node.to));
                    }
                },
            });
        }
        return view.Decoration.set(widgets);
    }
    return view.ViewPlugin.fromClass(class {
        constructor(view) {
            this.decorations = itemTag(view);
        }
        update(update) {
            if (update.docChanged || update.viewportChanged)
                this.decorations = itemTag(update.view);
        }
    }, {
        decorations: (instance) => instance.decorations,
        provide: (plugin) => view.EditorView.atomicRanges.of((view$1) => {
            var _a;
            return ((_a = view$1.plugin(plugin)) === null || _a === void 0 ? void 0 : _a.decorations) || view.Decoration.none;
        }),
    });
}

// 輸出 linter
const nuformulaLinter = () => {
    return lint.linter((view) => {
        let diagnostics = [];
        language.syntaxTree(view.state)
            .cursor()
            .iterate((node) => {
            if (node.type.isError) {
                diagnostics.push({
                    from: node.from,
                    to: node.to,
                    severity: "error",
                    message: node.name,
                });
            }
        });
        return diagnostics;
    }, {
        tooltipFilter: () => [],
    });
};

// 語言標籤樣式
function nuformulaHighlightStyle() {
    return language.syntaxHighlighting(language.HighlightStyle.define([
        { tag: highlight.tags.keyword, color: "#B157D0" },
        { tag: highlight.tags.string, color: "#F7A452" },
        { tag: highlight.tags.number, color: "#5C9CE5" },
        { tag: highlight.tags.operator, color: "#404040" },
        { tag: highlight.tags.variableName, color: "#6E7796" },
    ]));
}

/**
 * 偵測自動選字方法
 *
 * @param {Array} options - 可選選項
 * @returns {Function}
 */
function setAutocomplete(options) {
    return (context) => {
        let word = context.matchBefore(/(\w|[\u4E00-\u9FFF])*/);
        if (word.from == word.to && !context.explicit)
            return null;
        return {
            from: word.from,
            options: options,
        };
    };
}
/**
 * 輸出 自動選字 掛件
 *
 * @param {Object} options - 可選選項
 * @returns {Extension}
 */
function nuformulaAutocomplete(formItems) {
    const funcNameList = Object.values(funcName).map((func) => ({
        label: func,
        type: "method",
        apply: `${func}()`,
    }));
    const itemList = Object.values(formItems).map((value) => ({
        label: value.options.label,
        type: "variable",
        apply: `{${value.sn}}`,
    }));
    const autocompleteOptions = [].concat(funcNameList, itemList);
    return autocomplete.autocompletion({
        override: [setAutocomplete(autocompleteOptions)],
    });
}

// 定義語言
const NuformulaLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: context => context.column(context.node.from) + context.unit
            }),
            highlight.styleTags({
                Keyword: highlight.tags.keyword,
                String: highlight.tags.string,
                Number: highlight.tags.number,
                Operator: highlight.tags.operator,
                Item: highlight.tags.variableName,
                "( )": highlight.tags.paren,
                Comma: highlight.tags.separator,
            }),
        ],
    }),
});
// 輸出語言
function nuformula() {
    return new language.LanguageSupport(NuformulaLanguage);
}

exports.NuformulaLanguage = NuformulaLanguage;
exports.nuformula = nuformula;
exports.nuformulaAutocomplete = nuformulaAutocomplete;
exports.nuformulaHighlightStyle = nuformulaHighlightStyle;
exports.nuformulaItemWidget = nuformulaItemWidget;
exports.nuformulaLinter = nuformulaLinter;
